unit View.OrderEntryWeb;

interface

uses
  System.SysUtils, System.Generics.Collections, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, WEBLib.Menus, WEBLib.ExtCtrls, WEBLib.StdCtrls,
  WEBLib.JSON, Auth.Service, XData.Web.Client, WebLib.Storage,
  ConnectionModule, App.Types, Vcl.StdCtrls, Vcl.Controls, WEBLib.DBCtrls,
  Data.DB, XData.Web.JsonDataset, XData.Web.Dataset, WEBLib.DB;

type
  TFOrderEntryWeb = class(TWebForm)
    WebLabel2: TWebLabel;
    pnlMessage: TWebPanel;
    lblMessage: TWebLabel;
    btnCloseNotification: TWebButton;
    edtCompanyName: TWebDBEdit;
    edtCompanyAccountName: TWebDBEdit;
    edtInQuickBooks: TWebDBEdit;
    XDataWebClient1: TXDataWebClient;
    tmrScrollTop: TWebTimer;
    XDataWebDataSet1: TXDataWebDataSet;
    XDataWebDataSet1ORDER_ID: TIntegerField;
    XDataWebDataSet1COMPANY_ID: TIntegerField;
    XDataWebDataSet1USER_ID: TIntegerField;
    XDataWebDataSet1ORDER_DATE: TDateField;
    XDataWebDataSet1START_DATE: TDateField;
    XDataWebDataSet1END_DATE: TDateField;
    XDataWebDataSet1ORDER_STATUS: TStringField;
    XDataWebDataSet1SCHED_JSON: TStringField;
    XDataWebDataSet1NAME: TStringField;
    XDataWebDataSet1SHORT_NAME: TStringField;
    XDataWebDataSet1staff_fields_ship_via: TStringField;
    XDataWebDataSet1staff_fields_price: TStringField;
    XDataWebDataSet1staff_fields_invoice_to: TStringField;
    XDataWebDataSet1staff_fields_invoice_attention: TStringField;
    XDataWebDataSet1staff_fields_ship_to: TStringField;
    XDataWebDataSet1staff_fields_ship_attention: TStringField;
    XDataWebDataSet1staff_fields_po_number: TStringField;
    XDataWebDataSet1staff_fields_job_name: TStringField;
    XDataWebDataSet1plates_job_number: TStringField;
    XDataWebDataSet1supplied_by_customer_b_w_copy: TBooleanField;
    XDataWebDataSet1supplied_by_customer_dimension: TStringField;
    XDataWebDataSet1supplied_by_customer_e_mail: TStringField;
    XDataWebDataSet1supplied_by_customer_ftp: TStringField;
    XDataWebDataSet1supplied_by_customer_other: TStringField;
    XDataWebDataSet1supplied_by_customer_existing_: TStringField;
    XDataWebDataSet1supplied_by_customer_ref_art_p: TStringField;
    XDataWebDataSet1supplied_by_customer_ref_art_a: TStringField;
    XDataWebDataSet1cut_die_cutdier: TStringField;
    XDataWebDataSet1cut_die_cutdieb: TStringField;
    XDataWebDataSet1cut_die_cutdief: TStringField;
    XDataWebDataSet1cut_die_cutdierkr: TStringField;
    XDataWebDataSet1cut_die_cutdiefkr: TStringField;
    XDataWebDataSet1cut_die_cad_file: TStringField;
    XDataWebDataSet1cut_die_attached: TStringField;
    XDataWebDataSet1cut_die_boxpol250: TStringField;
    XDataWebDataSet1cut_die_boxpol155: TStringField;
    XDataWebDataSet1cut_die_boxpol125: TStringField;
    XDataWebDataSet1cut_die_brub: TStringField;
    XDataWebDataSet1proofing_fax: TStringField;
    XDataWebDataSet1proofing_fax_attn: TStringField;
    XDataWebDataSet1proofing_e_mail: TStringField;
    XDataWebDataSet1proofing_ship_to: TStringField;
    XDataWebDataSet1proofing_other: TStringField;
    XDataWebDataSet1proofing_changes_required: TStringField;
    XDataWebDataSet1proofing_changes_date: TDateField;
    XDataWebDataSet1layout_rsc_l: TStringField;
    XDataWebDataSet1layout_rcs_w: TStringField;
    XDataWebDataSet1layout_rcs_d: TStringField;
    XDataWebDataSet1layout_die_cut_no: TStringField;
    XDataWebDataSet1layout_accross_no: TStringField;
    XDataWebDataSet1layout_around_no: TStringField;
    XDataWebDataSet1layout_cad_file: TStringField;
    XDataWebDataSet1mounting_standard_setup: TStringField;
    XDataWebDataSet1mounting_custom_backing: TStringField;
    XDataWebDataSet1mounting_custom_adhesive: TStringField;
    XDataWebDataSet1colors_cylinder_size: TStringField;
    XDataWebDataSet1colors_cross_hairs: TStringField;
    XDataWebDataSet1colors_machine_ident: TStringField;
    XDataWebDataSet1colors_clemson: TStringField;
    XDataWebDataSet1plates_thickness: TStringField;
    XDataWebDataSet1plates_plate_material: TStringField;
    XDataWebDataSet1general_special_instructions: TStringField;
    XDataWebDataSet1colors_colors: TStringField;
    XDataWebDataSet1staff_fields_quickbooks_item: TStringField;
    XDataWebDataSet1staff_fields_quantity: TStringField;
    XDataWebDataSet1layout_rsc_style: TStringField;
    XDataWebDataSet1staff_fields_art_location: TStringField;
    XDataWebDataSet1supplied_by_customer_color_copy: TBooleanField;
    XDataWebDataSet1supplied_by_customer_plates: TBooleanField;
    XDataWebDataSet1supplied_by_customer_sample_ca: TBooleanField;
    XDataWebDataSet1supplied_by_customer_disk_or_cd: TBooleanField;
    XDataWebDataSet1mounting_loose: TStringField;
    XDataWebDataSet1mounting_sticky_bak: TBooleanField;
    XDataWebDataSet1mounting_full_mount: TBooleanField;
    XDataWebDataSet1mounting_strip_mount: TStringField;
    XDataWebDataSet1layout_excalibur_die: TBooleanField;
    XDataWebDataSet1proofing_full_size_panel: TBooleanField;
    XDataWebDataSet1proofing_print_card: TBooleanField;
    XDataWebDataSet1proofing_wide_format: TBooleanField;
    XDataWebDataSet1proofing_pdf_file: TBooleanField;
    XDataWebDataSet1proofing_art_approved_as_is: TBooleanField;
    XDataWebDataSet1proofing_e_mail_attn: TStringField;
    XDataWebDataSet1proofing_approved_date: TStringField;
    XDataWebDataSet1staff_fields_order_date: TStringField;
    XDataWebDataSet1staff_fields_proof_date: TStringField;
    XDataWebDataSet1staff_fields_ship_date: TStringField;
    XDataWebDataSet1staff_fields_art_due: TStringField;
    XDataWebDataSet1staff_fields_plate_due: TStringField;
    XDataWebDataSet1staff_fields_mount_due: TStringField;
    XDataWebDataSet1ADDRESS_LIST: TStringField;
    XDataWebDataSet1supplied_by_customer_order_date: TStringField;
    WebDataSource1: TWebDataSource;
    WebLabel1: TWebLabel;
    dtpOrderDate: TWebDateTimePicker;
    dtpProofDate: TWebDateTimePicker;
    dtpShipDate: TWebDateTimePicker;
    dtpArtDue: TWebDateTimePicker;
    dtpPlateDue: TWebDateTimePicker;
    edtShipVia: TWebDBEdit;
    edtQuantity: TWebDBEdit;
    edtPrice: TWebDBEdit;
    edtInvoiceTo: TWebDBEdit;
    edtPONumber: TWebDBEdit;
    edtJobName: TWebDBEdit;
    edtQuickBooksItem: TWebDBEdit;
    WebDBComboBox1: TWebDBComboBox;
    wdsShipTo: TWebDataSource;
    xdwdsShipTo: TXDataWebDataSet;
    xdwdsShipToADDRESS: TStringField;
    WebLabel3: TWebLabel;
    edtBWorColorCopy: TWebDBEdit;
    edtPlates: TWebDBEdit;
    edtDimensionalLayout: TWebDBEdit;
    edtSample: TWebDBEdit;
    edtDisk: TWebDBEdit;
    edtOther: TWebDBEdit;
    edtEmail: TWebDBEdit;
    edtTotalInchesUsed: TWebDBEdit;
    edtFTP: TWebDBEdit;
    edtSheetsUsed: TWebDBEdit;
    edtInitials: TWebDBEdit;
    WebLabel4: TWebLabel;
    cbPDF: TWebDBCheckBox;
    edtPDFTo: TWebDBEdit;
    dtpPDFDate1: TWebDateTimePicker;
    dtpPDFDate3: TWebDateTimePicker;
    dtpPDFDate2: TWebDateTimePicker;
    cbInkJet: TWebDBCheckBox;
    edtInkJetTo2: TWebDBEdit;
    edtInkJetTo1: TWebDBEdit;
    dtpInkJetDate1: TWebDateTimePicker;
    dtpInkJetDate3: TWebDateTimePicker;
    dtpInkJetDate2: TWebDateTimePicker;
    edtColorContrastTo: TWebDBEdit;
    edtColorContrast: TWebDBEdit;
    dtpColorContrastDate1: TWebDateTimePicker;
    dtpColorContrastDate2: TWebDateTimePicker;
    edtDigitalColorTo: TWebDBEdit;
    edtDigitalColorKey: TWebDBEdit;
    dtpDigitalColorDate: TWebDateTimePicker;
    WebLabel5: TWebLabel;
    edtAniloxInfo: TWebDBEdit;
    edtPressName: TWebDBEdit;
    WebButton1: TWebButton;
    WebLabel6: TWebLabel;
    edtMicroDots: TWebDBEdit;
    edtMicrodotsComments: TWebDBEdit;
    edtCrosshairsComments: TWebDBEdit;
    edtCrosshairs: TWebDBEdit;
    edtColorBarsComments: TWebDBEdit;
    edtColorBars: TWebDBEdit;
    edtPlateOther: TWebDBEdit;
    edtPlateOtherComments: TWebDBEdit;
    WebLabel7: TWebLabel;
    edtPrintOrientation: TWebDBEdit;
    WebLabel8: TWebLabel;
    edtAround: TWebDBEdit;
    edtAccross: TWebDBEdit;
    edtReversePrint: TWebDBEdit;
    edtSurfacePrint: TWebDBEdit;
    edtCutoffDimension: TWebDBEdit;
    edtCylinderRepeat: TWebDBEdit;
    edtPitch: TWebDBEdit;
    edtBleed: TWebDBEdit;
    edtTeeth: TWebDBEdit;
    edtCutback: TWebDBEdit;
    edtMinimumTrapDim: TWebDBEdit;
    edtMaximumTrapDim: TWebDBEdit;
    WebLabel9: TWebLabel;
    edtSize: TWebDBEdit;
    edtBarWidthReduction: TWebDBEdit;
    edtDistortionAmount: TWebDBEdit;
    edtDistortionPercent: TWebDBEdit;
    WebLabel10: TWebLabel;
    edtPlateMaterial: TWebDBEdit;
    edtThickness: TWebDBEdit;
    edtJobNumber: TWebDBEdit;
    WebLabel11: TWebLabel;
    Comments: TWebDBEdit;
    btnConfirm: TWebButton;
    btnEdit: TWebButton;
    btnCancel: TWebButton;
    procedure WebFormCreate(Sender: TObject);
    procedure HideNotification();
    procedure ShowNotification(Notification: string);
    procedure WebFormShow(Sender: TObject);
    [async] procedure getOrder(Order_ID: string);
    [async] procedure getCustomer(customerID: string);
    procedure tmrScrollTopTimer(Sender: TObject);
    procedure WebButton1Click(Sender: TObject);
    procedure addColorRow(num, Color, LPI, Size: string);
    procedure btnConfirmClick(Sender: TObject);
    [async] procedure AddCorrugatedOrder(orderJSON: TJSONObject);
    procedure btnCancelClick(Sender: TObject);
  private
    FAgencyCode: string;
    FCurrentReportType: string;
    FSelectProc: TSelectProc;
    orderID: string;
    customerID: string;
    mode: string;
    //FJSONProc1: TJSONProc1;
  public
    class function CreateForm(AElementID, orderInfo, customerInfo, mode: string): TWebForm;
  end;

var
  FOrderEntryWeb: TFOrderEntryWeb;

implementation

{$R *.dfm}

uses
  View.Home, View.Main;

procedure TFOrderEntryWeb.btnConfirmClick(Sender: TObject);
// Converts all the information on the page into a JSON to then send to the server
var
  colorList: TJSONArray;
  container: TJSElement;
  colorCollection: TJSHTMLCollection;
  color: TJSHTMLElement;
  I, J: integer;
  colorJSON, orderJSON, colorListJSON: TJSONObject;
  fieldNames: TStringList;
  itemList: TJSNodeList;
  header, value: string;
  Field: TField;
  Response: TXDataClientResponse;
begin
  orderJSON := TJSONObject.Create;
  colorList := TJSONArray.Create;
  container := document.getElementById('additionalFields');
  colorCollection := container.children;

  for I := 0 to colorCollection.length - 1 do
  begin
    colorJSON := TJSONObject.Create;
    itemList := colorCollection[I].childNodes;
    for J := 0 to itemList.length - 2 do
    begin
      header := TJSHTMLElement(itemList[J]).children[0].innerText.Replace(':', '').Trim();
      value := TJSHTMLInputElement(TJSHTMLElement(itemList[J]).childNodes[1]).value;
      colorJSON.AddPair(header, value);
    end;
    colorList.Add(colorJSON);
  end;
  colorListJSON := TJSONObject.Create;
  colorListJSON.AddPair('items', colorList);
  XDataWebDataSet1.Edit;

  XDataWebDataSet1colors_colors.Value := colorListJSON.ToString;

  //Convert all dates to strings because I was having less issues with that data type.
  XDataWebDataSet1staff_fields_proof_date.Value := DateTimeToStr(dtpProofDate.Date);
  XDataWebDataSet1staff_fields_ship_date.Value := DateTimeToStr(dtpShipDate.Date);
  XDataWebDataSet1staff_fields_art_due.Value := DateTimeToStr(dtpArtDue.Date);
  XDataWebDataSet1staff_fields_plate_due.Value := DateTimeToStr(dtpPlateDue.Date);
  XDataWebDataSet1staff_fields_order_date.Value := DateTimeToStr(dtpOrderDate.Date);

  //TODO add all other dtps

  // Convert all check boxes to strings because the database stores them as strings

  XDataWebDataSet1.Post;
  XDataWebDataSet1.First;
  while not XDataWebDataSet1.Eof do
  begin
    for Field in XDataWebDataSet1.Fields do
    begin
      if Field is TStringField then
      begin
        if Field.AsString = '' then
          orderJSON.AddPair(Field.FieldName, '')
        else
          orderJSON.AddPair(Field.FieldName, Field.AsString);  // Add all other fields
      end
      else if Field is TBooleanField then
      begin
        if Field.AsBoolean then
          orderJSON.AddPair(Field.FieldName, 'T')
        else
          orderJSON.AddPair(Field.FieldName, '');
      end;
    end;
    XDataWebDataSet1.Next;
  end;
  orderJSON.AddPair('COMPANY_ID', customerID);
  orderJSON.AddPair('USER_ID', '1011');
  orderJSON.AddPair('mode', mode);
  if mode = 'EDIT' then
    orderJSON.AddPair('ORDER_ID', orderID);
  AddCorrugatedOrder(orderJSON);
  FViewMain.ViewOrders('Success:Order Successfully Added');
end;

procedure TFOrderEntryWeb.AddCorrugatedOrder(orderJSON: TJSONObject);
// sends the order JSON object to the server
var
Response: TXDataClientResponse;
begin
  Response := await(XDataWebClient1.RawInvokeAsync('ILookupService.AddWebOrder',
              [orderJSON.ToString]));
end;

class function TFOrderEntryWeb.CreateForm(AElementID, orderInfo, customerInfo, mode: string): TWebForm;
var
  localMode: string;
begin
  localMode := mode;
  Application.CreateForm(TFOrderEntryWeb, AElementID, Result,
    procedure(AForm: TObject)
    begin
      with TFOrderEntryWeb(AForm) do
      begin
        HideNotification;
        TFOrderEntryWeb(AForm).customerID := customerInfo;
        TFOrderEntryWeb(AForm).orderID := orderInfo;
        TFOrderEntryWeb(AForm).mode := localMode;
      end;
    end
  );

end;

procedure TFOrderEntryWeb.addColorRow(num: string; Color: string; LPI: string; Size: string);
// Java script code to add a row of colors when a button is clicked
// all variables are information to be placed in the boxes when loading an order.
// TODO: convert to Delphi
begin
  asm
      const container = document.getElementById('additionalFields');

      // Create a new row for the new fields
      const newRow = document.createElement('div');
      newRow.className = 'row mb-2';

      const labels = ['#', 'Color', 'LPI', 'Size'];
      const values = [num, Color, LPI, Size];
      labels.forEach((label, index) => {
        const col = document.createElement('div');
        col.className = 'col-sm';

        const labelElement = document.createElement('label');
        labelElement.className = 'pe-2';
        labelElement.style.fontWeight = '700';
        labelElement.style.fontSize = '15px';
        labelElement.textContent = label + ':';

        const inputElement = document.createElement('input');
        inputElement.className = 'form-control input-sm';
        inputElement.style.width = '100%';
        inputElement.id =  'input-' + container.childElementCount + '-' + index; // Unique ID based on count
        inputElement.value = values[index];  // Set the value based on the parameter

        col.appendChild(labelElement);
        col.appendChild(inputElement);

        newRow.appendChild(col);
      });

      const removeButtonCol = document.createElement('div');
      removeButtonCol.className = 'col-auto d-flex align-items-center';

      const removeButton = document.createElement('button');
      removeButton.className = 'btn btn-danger btn-sm';
      removeButton.textContent = 'Remove';
      removeButton.addEventListener('click', function() {
        container.removeChild(newRow);
      });

      removeButtonCol.appendChild(removeButton);
      newRow.appendChild(removeButtonCol);

      container.appendChild(newRow);
    end;
end;

procedure TFOrderEntryWeb.WebButton1Click(Sender: TObject);
begin
  addColorRow('','','','');
end;

procedure TFOrderEntryWeb.btnCancelClick(Sender: TObject);
begin
  FViewMain.ViewOrders('');
end;

procedure TFOrderEntryWeb.WebFormCreate(Sender: TObject);
begin
   if not DMConnection.ApiConnection.Connected then
   begin
    DMConnection.ApiConnection.OpenAsync;
    console.log('report requirements connection open')
   end;
end;

procedure TFOrderEntryWeb.getOrder(Order_ID: string);
// retrieves an order from the server then loads the info into the page
var
  xdcResponse: TXDataClientResponse;
  orderList : TJSObject;
  i: integer;
  data: TJSArray;
  order: TJSObject;
  callListLength: integer;
  tempString, strColorList: string;
  colorObject: TJSObject;
  colorList: TJSArray;
  colorLength: integer;
  color: TJSObject;
  colorJSON: TJSONObject;
  colorListJSON: TJSONArray;
begin
  xdcResponse := await(XDataWebClient1.RawInvokeAsync('ILookupService.GetOrder',
        [Order_ID]));
  order :=  TJSObject(xdcResponse.Result);
  data := TJSArray(order['data']);
  XDataWebDataSet1.Close;
  XDataWebDataSet1.SetJsonData(order);
  XDataWebDataSet1.Open;
  if XDataWebDataSet1colors_colors.Value <> '' then
  begin
  colorObject := TJSObject(TJSJSON.parse(XDataWebDataSet1colors_colors.Value));
  colorList := TJSArray(colorObject['items']);
  for I := 0 to colorList.length -1 do
    begin
      color := TJSObject(colorList[i]);
      addColorRow(String(color['#']), string(color['Color']), string(color['LPI']), string(color['Size']));
    end;
  end;

  // Check boxes and dates need to be manually set

  if not (XDataWebDataSet1staff_fields_order_date.AsString = '') then
    dtpOrderDate.Date := StrToDateTime(XDataWebDataSet1staff_fields_order_date.Value)
  else
    dtpOrderDate.Date := 0;
  if not (XDataWebDataSet1staff_fields_proof_date.AsString = '') then
    dtpProofDate.Date := StrToDateTime(XDataWebDataSet1staff_fields_proof_date.AsString)
  else
    dtpProofDate.Date := 0;
  if not (XDataWebDataSet1staff_fields_ship_date.AsString = '') then
    dtpShipDate.Date := StrToDateTime(XDataWebDataSet1staff_fields_ship_date.AsString)
  else
    dtpShipDate.Date := 0;
  if not (XDataWebDataSet1staff_fields_art_due.AsString = '') then
    dtpArtDue.Date := StrToDateTime(XDataWebDataSet1staff_fields_art_due.AsString)
  else
    dtpArtDue.Date := 0;
  if not (XDataWebDataSet1staff_fields_plate_due.AsString = '') then
    dtpPlateDue.Date := StrToDateTime(XDataWebDataSet1staff_fields_plate_due.AsString)
  else
    dtpPlateDue.Date := 0;

  //TODO Add other dtps

  if mode = 'EDIT' then
    CustomerID := XDataWebDataSet1COMPANY_ID.AsString;

end;

procedure TFOrderEntryWeb.getCustomer(customerID: string);
// gets a customer from the database then loads the appropiate fields
var
  xdcResponse: TXDataClientResponse;
  customer : TJSObject;
  address: string;
begin
  xdcResponse := await(XDataWebClient1.RawInvokeAsync('ILookupService.GetCustomer',
        [customerID]));
  customer :=  TJSObject(xdcResponse.Result);
  XDataWebDataSet1.Close;
  XDataWebDataSet1.SetJsonData(customer);
  XDataWebDataSet1.Open;



  xdwdsShipTo.Close;
  xdwdsShipTo.SetJSONData(customer['ADDRESS_LIST']);
  xdwdsShipTo.Open;

end;

procedure TFOrderEntryWeb.WebFormShow(Sender: TObject);
begin
  if mode <> 'ADD' then
    getOrder(orderID)
  else
    getCustomer(customerID);
  HideNotification();
end;

procedure TFOrderEntryWeb.HideNotification;
begin
  pnlMessage.ElementHandle.hidden := True;
end;

procedure TFOrderEntryWeb.ShowNotification(Notification: string);
begin
  if Notification <> '' then
  begin
    lblMessage.Caption := Notification;
    pnlMessage.ElementHandle.hidden := False;
  end;
end;


procedure TFOrderEntryWeb.tmrScrollTopTimer(Sender: TObject);
begin
  tmrScrollTop.Enabled := False;
  window.scrollTo(0, 0);
end;


end.